﻿using System.ComponentModel.DataAnnotations;
using Connected.Annotations;

namespace Connected.ServiceModel.Client.Data.Remote;
internal class TableArgs : ServiceArgs
{
}

internal sealed class QueryTableArgs : TableArgs
{
	[Required]
	public string CommandText { get; set; } = default!;
}

internal sealed class TableSchemaArgs : ServiceArgs
{
	[Required, MaxLength(128)]
	public string TableName { get; set; } = default!;
}

internal sealed class CreateTableArgs : ServiceArgs
{
	[Required, MaxLength(128)]
	public string Name { get; set; } = default!;
	[NonDefault]
	public List<RemoteTableColumn> Columns { get; set; }
}

internal sealed class UpdateTableArgs : ServiceArgs
{
	[Required]
	public string CommandText { get; set; } = default!;
}