﻿using Connected.Net;
using Connected.ServiceModel.Client.Net;
using Connected.ServiceModel.Client.Subscription;
using Connected.ServiceModel.Storage;
using Connected.Services;

namespace Connected.ServiceModel.Client.Storage;

internal sealed class DeleteDirectory : ServiceAction<DeleteDirectoryArgs>
{
	public DeleteDirectory(ISubscriptionService subscription, IHttpService http, IConnectedServer server, ICancellationContext cancel)
	{
		Subscription = subscription;
		Http = http;
		Server = server;
		Cancel = cancel;
	}

	public ISubscriptionService Subscription { get; }
	public IHttpService Http { get; }
	public IConnectedServer Server { get; }
	public ICancellationContext Cancel { get; }

	protected override async Task OnInvoke()
	{
		await Http.Post(await Server.SelectUrl(new ConnectedServerUrlArgs { Kind = ConnectedUrlKind.FileSystem }), Arguments, Cancel.CancellationToken);
	}
}
